1# source this file; set up for tests
2
3# Copyright (C) 2009-2023 Free Software Foundation, Inc.
4
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13# GNU General Public License for more details.
14
15# You should have received a copy of the GNU General Public License
16# along with this program.  If not, see <https://www.gnu.org/licenses/>.
17
18# Using this file in a test
19# =========================
20#
21# The typical skeleton of a test looks like this:
22#
23#   #!/bin/sh
24#   . "${srcdir=.}/init.sh"; path_prepend_ .
25#   Execute some commands.
26#   Note that these commands are executed in a subdirectory, therefore you
27#   need to prepend "../" to relative filenames in the build directory.
28#   Note that the "path_prepend_ ." is useful only if the body of your
29#   test invokes programs residing in the initial directory.
30#   For example, if the programs you want to test are in src/, and this test
31#   script is named tests/test-1, then you would use "path_prepend_ ../src",
32#   or perhaps export PATH='$(abs_top_builddir)/src$(PATH_SEPARATOR)'"$$PATH"
33#   to all tests via automake's TESTS_ENVIRONMENT.
34#   Set the exit code 0 for success, 77 for skipped, or 1 or other for failure.
35#   Use the skip_ and fail_ functions to print a diagnostic and then exit
36#   with the corresponding exit code.
37#   Exit $?
38
39# Executing a test that uses this file
40# ====================================
41#
42# Running a single test:
43#   $ make check TESTS=test-foo.sh
44#
45# Running a single test, with verbose output:
46#   $ make check TESTS=test-foo.sh VERBOSE=yes
47#
48# Running a single test, keeping the temporary directory:
49#   $ make check TESTS=test-foo.sh KEEP=yes
50#
51# Running a single test, with single-stepping:
52#   1. Go into a sub-shell:
53#   $ bash
54#   2. Set relevant environment variables from TESTS_ENVIRONMENT in the
55#      Makefile:
56#   $ export srcdir=../../tests # this is an example
57#   3. Execute the commands from the test, copy&pasting them one by one:
58#   $ . "$srcdir/init.sh"; path_prepend_ .
59#   ...
60#   4. Finally
61#   $ exit
62
63# =============================================================================
64# Elementary diagnostics
65
66ME_=`expr "./$0" : '.*/\(.*\)$'`
67
68# Prepare PATH_SEPARATOR.
69# The user is always right.
70if test "${PATH_SEPARATOR+set}" != set; then
71  # Determine PATH_SEPARATOR by trying to find /bin/sh in a PATH which
72  # contains only /bin. Note that ksh looks also at the FPATH variable,
73  # so we have to set that as well for the test.
74  PATH_SEPARATOR=:
75  (PATH='/bin;/bin'; FPATH=$PATH; sh -c :) >/dev/null 2>&1 \
76    && { (PATH='/bin:/bin'; FPATH=$PATH; sh -c :) >/dev/null 2>&1 \
77           || PATH_SEPARATOR=';'
78       }
79fi
80
81# We use a trap below for cleanup.  This requires us to go through
82# hoops to get the right exit status transported through the handler.
83# So use 'Exit STATUS' instead of 'exit STATUS' inside of the tests.
84# Turn off errexit here so that we don't trip the bug with OSF1/Tru64
85# sh inside this function.
86Exit () { set +e; (exit $1); exit $1; }
87
88# Print warnings (e.g., about skipped and failed tests) to this file number.
89# Override by defining to say, 9, in init.cfg, and putting say,
90#   export ...ENVVAR_SETTINGS...; $(SHELL) 9>&2
91# in the definition of TESTS_ENVIRONMENT in your tests/Makefile.am file.
92# This is useful when using automake's parallel tests mode, to print
93# the reason for skip/failure to console, rather than to the .log files.
94: ${stderr_fileno_=2}
95
96# Note that correct expansion of "$*" depends on IFS starting with ' '.
97# Always write the full diagnostic to stderr.
98# When stderr_fileno_ is not 2, also emit the first line of the
99# diagnostic to that file descriptor.
100warn_ ()
101{
102  # If IFS does not start with ' ', set it and emit the warning in a subshell.
103  case $IFS in
104    ' '*) printf '%s\n' "$*" >&2
105          test $stderr_fileno_ = 2 \
106            || { printf '%s\n' "$*" | sed 1q >&$stderr_fileno_ ; } ;;
107    *) (IFS=' '; warn_ "$@");;
108  esac
109}
110fail_ () { warn_ "$ME_: failed test: $@"; Exit 1; }
111skip_ () { warn_ "$ME_: skipped test: $@"; Exit 77; }
112fatal_ () { warn_ "$ME_: hard error: $@"; Exit 99; }
113framework_failure_ () { warn_ "$ME_: set-up failure: $@"; Exit 99; }
114
115# =============================================================================
116# Ensure the shell supports modern syntax.
117
118# Sanitize this shell to POSIX mode, if possible.
119DUALCASE=1; export DUALCASE
120if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
121  emulate sh
122  NULLCMD=:
123  alias -g '${1+"$@"}'='"$@"'
124  setopt NO_GLOB_SUBST
125else
126  case `(set -o) 2>/dev/null` in
127    *posix*) set -o posix ;;
128  esac
129fi
130
131# We require $(...) support unconditionally.
132# We require that the printf built-in work correctly regarding octal escapes;
133# this eliminates /bin/sh on AIX 7.2.
134# We require non-surprising "local" semantics (this eliminates dash).
135# This takes the admittedly draconian step of eliminating dash, because the
136# assignment tab=$(printf '\t') works fine, yet preceding it with "local "
137# transforms it into an assignment that sets the variable to the empty string.
138# That is too counter-intuitive, and can lead to subtle run-time malfunction.
139# The example below is less subtle in that with dash, it evokes the run-time
140# exception "dash: 1: local: 1: bad variable name".
141# We require a few additional shell features only when $EXEEXT is nonempty,
142# in order to support automatic $EXEEXT emulation:
143# - hyphen-containing alias names
144# - we prefer to use ${var#...} substitution, rather than having
145#   to work around lack of support for that feature.
146# The following code attempts to find a shell with support for these features.
147# If the current shell passes the test, we're done.  Otherwise, test other
148# shells until we find one that passes.  If one is found, re-exec it.
149# If no acceptable shell is found, skip the current test.
150#
151# The "...set -x; P=1 true 2>err..." test is to disqualify any shell that
152# emits "P=1" into err, as /bin/sh from SunOS 5.11 and OpenBSD 4.7 do.
153#
154# Use "9" to indicate success (rather than 0), in case some shell acts
155# like Solaris 10's /bin/sh but exits successfully instead of with status 2.
156
157# Eval this code in a subshell to determine a shell's suitability.
158# 10 - passes all tests; ok to use
159#  9 - ok, but enabling "set -x" corrupts app stderr; prefer higher score
160#  ? - not ok
161gl_shell_test_script_='
162test $(echo y) = y || exit 1
163LC_ALL=en_US.UTF-8 printf "\\351" 2>/dev/null \
164  | LC_ALL=C tr "\\351" x | LC_ALL=C grep "^x$" > /dev/null \
165  || exit 1
166printf "\\351" 2>/dev/null \
167  | LC_ALL=C tr "\\351" x | LC_ALL=C grep "^x$" > /dev/null \
168  || exit 1
169f_local_() { local v=1; }; f_local_ || exit 1
170f_dash_local_fail_() { local t=$(printf " 1"); }; f_dash_local_fail_
171score_=10
172if test "$VERBOSE" = yes; then
173  test -n "$( (exec 3>&1; set -x; P=1 true 2>&3) 2> /dev/null)" && score_=9
174fi
175test -z "$EXEEXT" && exit $score_
176shopt -s expand_aliases
177alias a-b="echo zoo"
178v=abx
179     test ${v%x} = ab \
180  && test ${v#a} = bx \
181  && test $(a-b) = zoo \
182  && exit $score_
183'
184
185if test "x$1" = "x--no-reexec"; then
186  shift
187else
188  # Assume a working shell.  Export to subshells (setup_ needs this).
189  gl_set_x_corrupts_stderr_=false
190  export gl_set_x_corrupts_stderr_
191
192  # Record the first marginally acceptable shell.
193  marginal_=
194
195  # Search for a shell that meets our requirements.
196  for re_shell_ in __current__ "${CONFIG_SHELL:-no_shell}" \
197      /bin/sh bash dash zsh pdksh fail
198  do
199    test "$re_shell_" = no_shell && continue
200
201    # If we've made it all the way to the sentinel, "fail" without
202    # finding even a marginal shell, skip this test.
203    if test "$re_shell_" = fail; then
204      test -z "$marginal_" && skip_ failed to find an adequate shell
205      re_shell_=$marginal_
206      break
207    fi
208
209    # When testing the current shell, simply "eval" the test code.
210    # Otherwise, run it via $re_shell_ -c ...
211    if test "$re_shell_" = __current__; then
212      # 'eval'ing this code makes Solaris 10's /bin/sh exit with
213      # $? set to 2.  It does not evaluate any of the code after the
214      # "unexpected" first '('.  Thus, we must run it in a subshell.
215      ( eval "$gl_shell_test_script_" ) > /dev/null 2>&1
216    else
217      "$re_shell_" -c "$gl_shell_test_script_" 2>/dev/null
218    fi
219
220    st_=$?
221
222    # $re_shell_ works just fine.  Use it.
223    if test $st_ = 10; then
224      gl_set_x_corrupts_stderr_=false
225      break
226    fi
227
228    # If this is our first marginally acceptable shell, remember it.
229    if test "$st_:$marginal_" = 9: ; then
230      marginal_="$re_shell_"
231      gl_set_x_corrupts_stderr_=true
232    fi
233  done
234
235  if test "$re_shell_" != __current__; then
236    # Found a usable shell.  Preserve -v and -x.
237    case $- in
238      *v*x* | *x*v*) opts_=-vx ;;
239      *v*) opts_=-v ;;
240      *x*) opts_=-x ;;
241      *) opts_= ;;
242    esac
243    re_shell=$re_shell_
244    export re_shell
245    exec "$re_shell_" $opts_ "$0" --no-reexec "$@"
246    echo "$ME_: exec failed" 1>&2
247    exit 127
248  fi
249fi
250
251# =============================================================================
252# Ensure the shell behaves reasonably.
253
254# If this is bash, turn off all aliases.
255test -n "$BASH_VERSION" && unalias -a
256
257# Note that when supporting $EXEEXT (transparently mapping from PROG_NAME to
258# PROG_NAME.exe), we want to support hyphen-containing names like test-acos.
259# That is part of the shell-selection test above.  Why use aliases rather
260# than functions?  Because support for hyphen-containing aliases is more
261# widespread than that for hyphen-containing function names.
262test -n "$EXEEXT" && test -n "$BASH_VERSION" && shopt -s expand_aliases
263
264# =============================================================================
265# Creating a temporary directory (needed by the core test framework)
266
267# Create a temporary directory, much like mktemp -d does.
268# Written by Jim Meyering.
269#
270# Usage: mktempd_ /tmp phoey.XXXXXXXXXX
271#
272# First, try to use the mktemp program.
273# Failing that, we'll roll our own mktemp-like function:
274#  - try to get random bytes from /dev/urandom, mapping them to file-name bytes
275#  - failing that, generate output from a combination of quickly-varying
276#      sources and awk.
277#  - try to create the desired directory.
278#  - make only $MAX_TRIES_ attempts
279
280# Helper function.  Print $N pseudo-random bytes from a-zA-Z0-9.
281rand_bytes_ ()
282{
283  n_=$1
284
285  # Maybe try openssl rand -base64 $n_prime_|tr '+/=\012' abcd first?
286  # But if they have openssl, they probably have mktemp, too.
287
288  chars_=abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
289  dev_rand_=/dev/urandom
290  if test -r "$dev_rand_"; then
291    # Note: 256-length($chars_) == 194; 3 copies of $chars_ is 186 + 8 = 194.
292    dd ibs=$n_ count=1 if=$dev_rand_ 2>/dev/null \
293      | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
294    return
295  fi
296
297  # Fall back on quickly-varying sources + awk.
298  # Limit awk program to 7th Edition Unix so that it works even on Solaris 10.
299
300  (date; date +%N; free; who -a; w; ps auxww; ps -ef) 2>&1 | awk '
301     BEGIN {
302       n = '"$n_"'
303       for (i = 0; i < 256; i++)
304         ordinal[sprintf ("%c", i)] = i
305     }
306     {
307       for (i = 1; i <= length; i++)
308         a[ai++ % n] += ordinal[substr ($0, i, 1)]
309     }
310     END {
311       chars = "'"$chars_"'"
312       charslen = length (chars)
313       for (i = 0; i < n; i++)
314         printf "%s", substr (chars, a[i] % charslen + 1, 1)
315       printf "\n"
316     }
317  '
318}
319
320mktempd_ ()
321{
322  case $# in
323  2);;
324  *) fail_ "Usage: mktempd_ DIR TEMPLATE";;
325  esac
326
327  destdir_=$1
328  template_=$2
329
330  MAX_TRIES_=4
331
332  # Disallow any trailing slash on specified destdir:
333  # it would subvert the post-mktemp "case"-based destdir test.
334  case $destdir_ in
335  / | //) destdir_slash_=$destdir;;
336  */) fail_ "invalid destination dir: remove trailing slash(es)";;
337  *) destdir_slash_=$destdir_/;;
338  esac
339
340  case $template_ in
341  *XXXX) ;;
342  *) fail_ \
343       "invalid template: $template_ (must have a suffix of at least 4 X's)";;
344  esac
345
346  # First, try to use mktemp.
347  d=`unset TMPDIR; { mktemp -d -t -p "$destdir_" "$template_"; } 2>/dev/null` &&
348
349  # The resulting name must be in the specified directory.
350  case $d in "$destdir_slash_"*) :;; *) false;; esac &&
351
352  # It must have created the directory.
353  test -d "$d" &&
354
355  # It must have 0700 permissions.  Handle sticky "S" bits.
356  perms=`ls -dgo "$d" 2>/dev/null` &&
357  case $perms in drwx--[-S]---*) :;; *) false;; esac && {
358    echo "$d"
359    return
360  }
361
362  # If we reach this point, we'll have to create a directory manually.
363
364  # Get a copy of the template without its suffix of X's.
365  base_template_=`echo "$template_"|sed 's/XX*$//'`
366
367  # Calculate how many X's we've just removed.
368  template_length_=`echo "$template_" | wc -c`
369  nx_=`echo "$base_template_" | wc -c`
370  nx_=`expr $template_length_ - $nx_`
371
372  err_=
373  i_=1
374  while :; do
375    X_=`rand_bytes_ $nx_`
376    candidate_dir_="$destdir_slash_$base_template_$X_"
377    err_=`mkdir -m 0700 "$candidate_dir_" 2>&1` \
378      && { echo "$candidate_dir_"; return; }
379    test $MAX_TRIES_ -le $i_ && break;
380    i_=`expr $i_ + 1`
381  done
382  fail_ "$err_"
383}
384
385# =============================================================================
386# Core test framework
387
388# An arbitrary prefix to help distinguish test directories.
389testdir_prefix_ () { printf gt; }
390
391# Set up the environment for the test to run in.
392setup_ ()
393{
394  if test "$VERBOSE" = yes; then
395    # Test whether set -x may cause the selected shell to corrupt an
396    # application's stderr.  Many do, including zsh-4.3.10 and the /bin/sh
397    # from SunOS 5.11, OpenBSD 4.7 and Irix 6.5.
398    # If enabling verbose output this way would cause trouble, simply
399    # issue a warning and refrain.
400    if $gl_set_x_corrupts_stderr_; then
401      warn_ "using SHELL=$SHELL with 'set -x' corrupts stderr"
402    else
403      set -x
404    fi
405  fi
406
407  initial_cwd_=$PWD
408
409  # Create and enter the temporary directory.
410  pfx_=`testdir_prefix_`
411  test_dir_=`mktempd_ "$initial_cwd_" "$pfx_-$ME_.XXXX"` \
412    || fail_ "failed to create temporary directory in $initial_cwd_"
413  cd "$test_dir_" || fail_ "failed to cd to temporary directory"
414  # Set variables srcdir, builddir, for the convenience of the test.
415  case $srcdir in
416    /* | ?:*) ;;
417    *) srcdir="../$srcdir" ;;
418  esac
419  builddir=".."
420  export srcdir builddir
421
422  # As autoconf-generated configure scripts do, ensure that IFS
423  # is defined initially, so that saving and restoring $IFS works.
424  gl_init_sh_nl_='
425'
426  IFS=" ""	$gl_init_sh_nl_"
427
428  # This trap statement, along with a trap on 0 below, ensure that the
429  # temporary directory, $test_dir_, is removed upon exit as well as
430  # upon receipt of any of the listed signals.
431  for sig_ in 1 2 3 13 15; do
432    eval "trap 'Exit $(expr $sig_ + 128)' $sig_"
433  done
434
435  # Remove relative and non-accessible directories from PATH, including '.'
436  # and Zero-length entries.
437  saved_IFS="$IFS"
438  IFS=:
439  new_PATH=
440  sep_=
441  for dir in $PATH; do
442    case "$dir" in
443      /*) test -d "$dir/." || continue
444          new_PATH="${new_PATH}${sep_}${dir}"
445          sep_=':';;
446    esac
447  done
448  IFS="$saved_IFS"
449  PATH="$new_PATH"
450  export PATH
451}
452
453# This is a stub function that is run upon trap (upon regular exit and
454# interrupt).  Override it with a per-test function, e.g., to unmount
455# a partition, or to undo any other global state changes.
456cleanup_ () { :; }
457
458# Run the user-overridable cleanup_ function, remove the temporary
459# directory and exit with the incoming value of $?.
460remove_tmp_ ()
461{
462  __st=$?
463  cleanup_
464  if test "$KEEP" = yes; then
465    echo "Not removing temporary directory $test_dir_"
466  else
467    # cd out of the directory we're about to remove
468    cd "$initial_cwd_" || cd / || cd /tmp
469    chmod -R u+rwx "$test_dir_"
470    # If removal fails and exit status was to be 0, then change it to 1.
471    rm -rf "$test_dir_" || { test $__st = 0 && __st=1; }
472  fi
473  exit $__st
474}
475
476# =============================================================================
477# Prepending directories to PATH
478
479# Given a directory name, DIR, if every entry in it that matches *.exe
480# contains only the specified bytes (see the case stmt below), then print
481# a space-separated list of those names and return 0.  Otherwise, don't
482# print anything and return 1.  Naming constraints apply also to DIR.
483find_exe_basenames_ ()
484{
485  feb_dir_=$1
486  feb_fail_=0
487  feb_result_=
488  feb_sp_=
489  for feb_file_ in $feb_dir_/*.exe; do
490    # If there was no *.exe file, or there existed a file named "*.exe" that
491    # was deleted between the above glob expansion and the existence test
492    # below, just skip it.
493    test "x$feb_file_" = "x$feb_dir_/*.exe" && test ! -f "$feb_file_" \
494      && continue
495    # Exempt [.exe, since we can't create a function by that name, yet
496    # we can't invoke [ by PATH search anyways due to shell builtins.
497    test "x$feb_file_" = "x$feb_dir_/[.exe" && continue
498    case $feb_file_ in
499      *[!-a-zA-Z/0-9_.+]*) feb_fail_=1; break;;
500      *) # Remove leading file name components as well as the .exe suffix.
501         feb_file_=${feb_file_##*/}
502         feb_file_=${feb_file_%.exe}
503         feb_result_="$feb_result_$feb_sp_$feb_file_";;
504    esac
505    feb_sp_=' '
506  done
507  test $feb_fail_ = 0 && printf %s "$feb_result_"
508  return $feb_fail_
509}
510
511# Consider the files in directory, $1.
512# For each file name of the form PROG.exe, create an alias named
513# PROG that simply invokes PROG.exe, then return 0.  If any selected
514# file name or the directory name, $1, contains an unexpected character,
515# define no alias and return 1.
516create_exe_shims_ ()
517{
518  case $EXEEXT in
519    '') return 0 ;;
520    .exe) ;;
521    *) echo "$0: unexpected \$EXEEXT value: $EXEEXT" 1>&2; return 1 ;;
522  esac
523
524  base_names_=`find_exe_basenames_ $1` \
525    || { echo "$0 (exe_shim): skipping directory: $1" 1>&2; return 0; }
526
527  if test -n "$base_names_"; then
528    for base_ in $base_names_; do
529      alias "$base_"="$base_$EXEEXT"
530    done
531  fi
532
533  return 0
534}
535
536# Use this function to prepend to PATH an absolute name for each
537# specified, possibly-$initial_cwd_-relative, directory.
538path_prepend_ ()
539{
540  while test $# != 0; do
541    path_dir_=$1
542    case $path_dir_ in
543      '') fail_ "invalid path dir: '$1'";;
544      /* | ?:*) abs_path_dir_=$path_dir_;;
545      *) abs_path_dir_=$initial_cwd_/$path_dir_;;
546    esac
547    case $abs_path_dir_ in
548      *$PATH_SEPARATOR*) fail_ "invalid path dir: '$abs_path_dir_'";;
549    esac
550    PATH="$abs_path_dir_$PATH_SEPARATOR$PATH"
551
552    # Create an alias, FOO, for each FOO.exe in this directory.
553    create_exe_shims_ "$abs_path_dir_" \
554      || fail_ "something failed (above): $abs_path_dir_"
555    shift
556  done
557  export PATH
558}
559
560# =============================================================================
561# Convenience environment variables for the tests
562
563# -----------------------------------------------------------------------------
564
565# Enable glibc's malloc-perturbing option.
566# This is useful for exposing code that depends on the fact that
567# malloc-related functions often return memory that is mostly zeroed.
568# If you have the time and cycles, use valgrind to do an even better job.
569: ${MALLOC_PERTURB_=87}
570export MALLOC_PERTURB_
571
572# -----------------------------------------------------------------------------
573
574# The interpreter for Bourne-shell scripts.
575# No special standards compatibility requirements.
576# Some environments, such as Android, don't have /bin/sh.
577if test -f /bin/sh$EXEEXT; then
578  BOURNE_SHELL=/bin/sh
579else
580  BOURNE_SHELL=sh
581fi
582
583# =============================================================================
584# Convenience functions for the tests
585
586# -----------------------------------------------------------------------------
587# Return value checking
588
589# This is used to simplify checking of the return value
590# which is useful when ensuring a command fails as desired.
591# I.e., just doing `command ... &&fail=1` will not catch
592# a segfault in command for example.  With this helper you
593# instead check an explicit exit code like
594#   returns_ 1 command ... || fail
595returns_ () {
596  # Disable tracing so it doesn't interfere with stderr of the wrapped command
597  { set +x; } 2>/dev/null
598
599  local exp_exit="$1"
600  shift
601  "$@"
602  test $? -eq $exp_exit && ret_=0 || ret_=1
603
604  if test "$VERBOSE" = yes && test "$gl_set_x_corrupts_stderr_" = false; then
605    set -x
606  fi
607  { return $ret_; } 2>/dev/null
608}
609
610# -----------------------------------------------------------------------------
611# Text file comparison
612
613# Emit a header similar to that from diff -u;  Print the simulated "diff"
614# command so that the order of arguments is clear.  Don't bother with @@ lines.
615emit_diff_u_header_ ()
616{
617  printf '%s\n' "diff -u $*" \
618    "--- $1	1970-01-01" \
619    "+++ $2	1970-01-01"
620}
621
622# Arrange not to let diff or cmp operate on /dev/null,
623# since on some systems (at least OSF/1 5.1), that doesn't work.
624# When there are not two arguments, or no argument is /dev/null, return 2.
625# When one argument is /dev/null and the other is not empty,
626# cat the nonempty file to stderr and return 1.
627# Otherwise, return 0.
628compare_dev_null_ ()
629{
630  test $# = 2 || return 2
631
632  if test "x$1" = x/dev/null; then
633    test -s "$2" || return 0
634    emit_diff_u_header_ "$@"; sed 's/^/+/' "$2"
635    return 1
636  fi
637
638  if test "x$2" = x/dev/null; then
639    test -s "$1" || return 0
640    emit_diff_u_header_ "$@"; sed 's/^/-/' "$1"
641    return 1
642  fi
643
644  return 2
645}
646
647for diff_opt_ in -u -U3 -c '' no; do
648  test "$diff_opt_" != no &&
649    diff_out_=`exec 2>/dev/null
650      LC_ALL=C diff $diff_opt_ "$0" "$0" < /dev/null` &&
651    break
652done
653if test "$diff_opt_" != no; then
654  if test -z "$diff_out_"; then
655    compare_ () { LC_ALL=C diff $diff_opt_ "$@"; }
656  else
657    compare_ ()
658    {
659      # If no differences were found, AIX and HP-UX 'diff' produce output
660      # like "No differences encountered".  Hide this output.
661      LC_ALL=C diff $diff_opt_ "$@" > diff.out
662      diff_status_=$?
663      test $diff_status_ -eq 0 || cat diff.out || diff_status_=2
664      rm -f diff.out || diff_status_=2
665      return $diff_status_
666    }
667  fi
668elif cmp -s /dev/null /dev/null 2>/dev/null; then
669  compare_ () { cmp -s "$@"; }
670else
671  compare_ () { cmp "$@"; }
672fi
673
674# Usage: compare EXPECTED ACTUAL
675#
676# Given compare_dev_null_'s preprocessing, defer to compare_ if 2 or more.
677# Otherwise, propagate $? to caller: any diffs have already been printed.
678compare ()
679{
680  # This looks like it can be factored to use a simple "case $?"
681  # after unchecked compare_dev_null_ invocation, but that would
682  # fail in a "set -e" environment.
683  if compare_dev_null_ "$@"; then
684    return 0
685  else
686    case $? in
687      1) return 1;;
688      *) compare_ "$@";;
689    esac
690  fi
691}
692
693# -----------------------------------------------------------------------------
694
695# If you want to override the testdir_prefix_ function,
696# or to add more utility functions, use this file.
697test -f "$srcdir/init.cfg" \
698  && . "$srcdir/init.cfg"
699
700# =============================================================================
701# Set up the environment for the test to run in.
702
703setup_ "$@"
704# This trap is here, rather than in the setup_ function, because some
705# shells run the exit trap at shell function exit, rather than script exit.
706trap remove_tmp_ EXIT
707